# PyPOPS 0.1b (20/12/2007)
# A Graphical User Interface for Dark_Alex's popstation's binaries.
# author: darkthrone (drkthrn@gmail.com)

from Tkinter import *
from tkFileDialog import askopenfilename
from os import system,mkdir

class App:
    def __init__(self, master):

        frame = Frame(master)
        
        self.label1 = Label(frame, text="Image #1:")
        self.label1.grid(row=0, column=0, sticky=E)
        self.label12 = Label(frame, text="Compress Level (1-9):")
        self.label12.grid(row=0, column=3)


        self.text1 = Entry(frame, width=40)
        self.text1.grid(row=0,column=1)
        self.text12 = Entry(frame, width=1)
        self.text12.grid(row=0,column=4)
        self.text12.insert(INSERT,"9")

        self.button1 = Button(frame, text="Browse", command=self.browseFile1)
        self.button1.grid(row=0,column=2)
        
        self.label2 = Label(frame, text="Image #2:")
        self.label2.grid(row=1,column=0, sticky=E)
        self.label22 = Label(frame, text="Compress Level (1-9):")
        self.label22.grid(row=1, column=3)

        self.text2 = Entry(frame, width=40)
        self.text2.grid(row=1,column=1)        
        self.text22 = Entry(frame, width=1)
        self.text22.grid(row=1,column=4)
        self.text22.insert(INSERT,"9")
        
        self.button2 = Button(frame, text="Browse", command=self.browseFile2)
        self.button2.grid(row=1,column=2)

        self.label3 = Label(frame, text="Image #3:")
        self.label3.grid(row=2,column=0, sticky=E)
        self.label32 = Label(frame, text="Compress Level (1-9):")
        self.label32.grid(row=2, column=3)

        self.text3 = Entry(frame, width=40)
        self.text3.grid(row=2,column=1)
        self.text32 = Entry(frame, width=1)
        self.text32.grid(row=2,column=4)
        self.text32.insert(INSERT,"9")
        
        self.button3 = Button(frame, text="Browse", command=self.browseFile3)
        self.button3.grid(row=2,column=2)

        self.label4 = Label(frame, text="Image #4:")
        self.label4.grid(row=3,column=0, sticky=E)
        self.label42 = Label(frame, text="Compress Level (1-9):")
        self.label42.grid(row=3, column=3)

        self.text4 = Entry(frame, width=40)
        self.text4.grid(row=3,column=1)
        self.text42 = Entry(frame, width=1)
        self.text42.grid(row=3,column=4)
        self.text42.insert(INSERT,"9")
        
        self.button4 = Button(frame, text="Browse", command=self.browseFile4)
        self.button4.grid(row=3,column=2)

        self.label5 = Label(frame, text="Image #5:")
        self.label5.grid(row=4,column=0, sticky=E)
        self.label52 = Label(frame, text="Compress Level (1-9):")
        self.label52.grid(row=4, column=3)

        self.text5 = Entry(frame, width=40)
        self.text5.grid(row=4,column=1)
        self.text52 = Entry(frame, width=1)
        self.text52.grid(row=4,column=4)
        self.text52.insert(INSERT,"9")
        
        self.button5 = Button(frame, text="Browse", command=self.browseFile5)
        self.button5.grid(row=4,column=2)

        self.label6 = Label(frame, text="Game Title:")
        self.label6.grid(row=5,column=0, sticky=E)

        self.text6 = Entry(frame, width=40)
        self.text6.grid(row=5,column=1)

        self.label7 = Label(frame, text="Game Code:")
        self.label7.grid(row=6,column=0, sticky=E)

        self.text7 = Entry(frame, width=40)
        self.text7.grid(row=6,column=1)

        self.button6 = Button(frame, text="Make EBOOT", command=self.make)
        self.button6.grid(row=6,column=3)

        self.button6 = Button(frame, text="Quit", command=frame.quit)
        self.button6.grid(row=6,column=4)

        frame.pack()        
        
    def make(self):
        outputGameList = []
        outputCompressLvlList = []
        if self.text1.get():
            outputGameList.append(self.text1.get())
            outputCompressLvlList.append(int(self.text12.get()))
        if self.text2.get():
            outputGameList.append(self.text2.get())
            outputCompressLvlList.append(int(self.text22.get()))
        if self.text3.get():
            outputGameList.append(self.text3.get())
            outputCompressLvlList.append(int(self.text32.get()))
        if self.text4.get():
            outputGameList.append(self.text4.get())
            outputCompressLvlList.append(int(self.text42.get()))
        if self.text5.get():
            outputGameList.append(self.text5.get())
            outputCompressLvlList.append(int(self.text52.get()))
        if len(outputGameList) == 1:
            output = 'popstation "%s" %s %d "%s"' % (self.text6.get(),self.text7.get(),outputCompressLvlList[0], outputGameList[0])
        else:
            output = "popstation_md "
            for i in range(len(outputGameList)+1):
                output += '"%s" ' % self.text6.get()
            for i in range(len(outputGameList)+1):
                output += "%s " % self.text7.get()
            for i in range(len(outputGameList)):
                output += "%d " % outputCompressLvlList[i]
            for i in outputGameList:
                output += '"%s" ' % i
        mkdir("%s" % self.text6.get())        
        system("%s" % output)
        system("move EBOOT.PBP %s" % self.text6.get())

    def browseFile1(self):        
        fileformats = [('PSX Images','*.bin;*.iso;*.img')]
        filenameStr = askopenfilename(title="Choose The Image", filetypes=fileformats)
        self.text1.delete(0,END)     
        self.text1.insert(INSERT,filenameStr)

    def browseFile2(self):        
        fileformats = [('PSX Images','*.bin;*.iso;*.img')]
        filenameStr = askopenfilename(title="Choose The Image", filetypes=fileformats)
        self.text2.delete(0,END)     
        self.text2.insert(INSERT,filenameStr)

    def browseFile3(self):        
        fileformats = [('PSX Images','*.bin;*.iso;*.img')]
        filenameStr = askopenfilename(title="Choose The Image", filetypes=fileformats)
        self.text3.delete(0,END)     
        self.text3.insert(INSERT,filenameStr)

    def browseFile4(self):        
        fileformats = [('PSX Images','*.bin;*.iso;*.img')]
        filenameStr = askopenfilename(title="Choose The Image", filetypes=fileformats)
        self.text4.delete(0,END)     
        self.text4.insert(INSERT,filenameStr)

    def browseFile5(self):        
        fileformats = [('PSX Images','*.bin;*.iso;*.img')]
        filenameStr = askopenfilename(title="Choose The Image", filetypes=fileformats)
        self.text5.delete(0,END)     
        self.text5.insert(INSERT,filenameStr)

root = Tk()
root.withdraw()
root.title("PyPOPS 0.1b by darkthrone")
app = App(root)
root.update()
root.deiconify()
root.mainloop()
